diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/two-ray-spectrum-propagation-loss-model.cc ns-3.41/src/spectrum/model/two-ray-spectrum-propagation-loss-model.cc
--- ns-3.40/src/spectrum/model/two-ray-spectrum-propagation-loss-model.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/two-ray-spectrum-propagation-loss-model.cc	2024-02-09 14:44:08.501794300 -0800
@@ -1052,11 +1052,11 @@
     std::complex<double> bArrayOverallResponse = 0;
 
     // Compute the dot products between the array responses and the beamforming vectors
-    for (size_t i = 0; i < aPhasedArrayModel->GetNumberOfElements(); i++)
+    for (size_t i = 0; i < aPhasedArrayModel->GetNumElems(); i++)
     {
         aArrayOverallResponse += aArrayResponse[i] * aBfVector[i];
     }
-    for (size_t i = 0; i < bPhasedArrayModel->GetNumberOfElements(); i++)
+    for (size_t i = 0; i < bPhasedArrayModel->GetNumElems(); i++)
     {
         bArrayOverallResponse += bArrayResponse[i] * bBfVector[i];
     }
@@ -1112,7 +1112,7 @@
     return norm(h);
 }
 
-Ptr<SpectrumValue>
+Ptr<SpectrumSignalParameters>
 TwoRaySpectrumPropagationLossModel::DoCalcRxPowerSpectralDensity(
     Ptr<const SpectrumSignalParameters> params,
     Ptr<const MobilityModel> a,
@@ -1128,8 +1128,6 @@
     NS_ASSERT_MSG(a->GetDistanceFrom(b) > 0.0,
                   "The position of a and b devices cannot be the same");
 
-    Ptr<SpectrumValue> rxPsd = Copy<SpectrumValue>(params->psd);
-
     // Retrieve the antenna of device a
     NS_ASSERT_MSG(aPhasedArrayModel, "Antenna not found for node " << aId);
     NS_LOG_DEBUG("a node " << a->GetObject<Node>() << " antenna " << aPhasedArrayModel);
@@ -1147,10 +1145,11 @@
     // Compute the beamforming gain
     double bfGain = CalcBeamformingGain(a, b, aPhasedArrayModel, bPhasedArrayModel);
 
-    // Apply the above terms to the TX PSD
-    *rxPsd *= (fading * bfGain);
+    Ptr<SpectrumSignalParameters> rxParams = params->Copy();
+    // Apply the above terms to the TX PSD to calculate RX PSD
+    (*(rxParams->psd)) *= (fading * bfGain);
 
-    return rxPsd;
+    return rxParams;
 }
 
 std::size_t
@@ -1166,7 +1165,7 @@
 }
 
 int64_t
-TwoRaySpectrumPropagationLossModel::AssignStreams(int64_t stream)
+TwoRaySpectrumPropagationLossModel::DoAssignStreams(int64_t stream)
 {
     NS_LOG_FUNCTION(this << stream);
     m_normalRv->SetStream(stream);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/two-ray-spectrum-propagation-loss-model.h ns-3.41/src/spectrum/model/two-ray-spectrum-propagation-loss-model.h
--- ns-3.40/src/spectrum/model/two-ray-spectrum-propagation-loss-model.h	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/two-ray-spectrum-propagation-loss-model.h	2024-02-09 14:44:08.501794300 -0800
@@ -163,15 +163,6 @@
     void SetFrequency(double f);
 
     /**
-     * \brief Assign a fixed random variable stream number to the random variables
-     * used by this model.
-     *
-     * \param stream first stream index to use
-     * \return the number of stream indices assigned by this model
-     */
-    int64_t AssignStreams(int64_t stream);
-
-    /**
      * \brief Compute the received PSD.
      *
      * This function computes the received PSD by applying the Fluctuating Two-Ray (FTR)
@@ -186,15 +177,18 @@
      * \param b second node mobility model
      * \param aPhasedArrayModel the antenna array of the first node
      * \param bPhasedArrayModel the antenna array of the second node
-     * \return the PSD of the received signal
+     * \return SpectrumSignalParameters including the PSD of the received signal
      */
-    Ptr<SpectrumValue> DoCalcRxPowerSpectralDensity(
+    Ptr<SpectrumSignalParameters> DoCalcRxPowerSpectralDensity(
         Ptr<const SpectrumSignalParameters> txPsd,
         Ptr<const MobilityModel> a,
         Ptr<const MobilityModel> b,
         Ptr<const PhasedArrayModel> aPhasedArrayModel,
         Ptr<const PhasedArrayModel> bPhasedArrayModel) const override;
 
+  protected:
+    int64_t DoAssignStreams(int64_t stream) override;
+
   private:
     /**
      * Retrieves the LOS condition associated to the specified mobility models
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/test/examples-to-run.py ns-3.41/src/spectrum/test/examples-to-run.py
--- ns-3.40/src/spectrum/test/examples-to-run.py	2023-09-27 13:30:37.878839700 -0700
+++ ns-3.41/src/spectrum/test/examples-to-run.py	2024-02-09 14:44:08.501794300 -0800
@@ -10,7 +10,7 @@
     ("adhoc-aloha-ideal-phy", "True", "True"),
     ("adhoc-aloha-ideal-phy-with-microwave-oven", "True", "True"),
     ("adhoc-aloha-ideal-phy-matrix-propagation-loss-model", "True", "True"),
-    ("three-gpp-channel-example", "True", "True")
+    ("three-gpp-channel-example", "True", "True"),
 ]
 
 # A list of Python examples to run in order to ensure that they remain
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/test/three-gpp-channel-test-suite.cc ns-3.41/src/spectrum/test/three-gpp-channel-test-suite.cc
--- ns-3.40/src/spectrum/test/three-gpp-channel-test-suite.cc	2023-09-27 13:30:37.878839700 -0700
+++ ns-3.41/src/spectrum/test/three-gpp-channel-test-suite.cc	2024-02-09 14:44:08.501794300 -0800
@@ -26,16 +26,20 @@
 #include "ns3/log.h"
 #include "ns3/node-container.h"
 #include "ns3/pointer.h"
+#include "ns3/rng-seed-manager.h"
 #include "ns3/simple-net-device.h"
 #include "ns3/simulator.h"
 #include "ns3/spectrum-signal-parameters.h"
 #include "ns3/string.h"
 #include "ns3/test.h"
+#include "ns3/three-gpp-antenna-model.h"
 #include "ns3/three-gpp-channel-model.h"
 #include "ns3/three-gpp-spectrum-propagation-loss-model.h"
 #include "ns3/uinteger.h"
 #include "ns3/uniform-planar-array.h"
 
+#include <valarray>
+
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE("ThreeGppChannelTestSuite");
@@ -51,9 +55,19 @@
 {
   public:
     /**
-     * Constructor
+     *Constructor
+     * \param txAntennaElements the number of rows and columns of the antenna array of the
+     * transmitter
+     * \param rxAntennaElements the number of rows and columns of the antenna array of
+     * \param txPorts the number of vertical and horizontal ports of the antenna array
+     * of the transmitter
+     * \param rxPorts the number of vertical and horizontal ports of the antenna
+     * array of the receiver
      */
-    ThreeGppChannelMatrixComputationTest();
+    ThreeGppChannelMatrixComputationTest(uint32_t txAntennaElements = 2,
+                                         uint32_t rxAntennaElements = 2,
+                                         uint32_t txPorts = 1,
+                                         uint32_t rxPorts = 1);
 
     /**
      * Destructor
@@ -81,11 +95,23 @@
                        Ptr<PhasedArrayModel> rxAntenna);
 
     std::vector<double> m_normVector; //!< each element is the norm of a channel realization
+    uint32_t m_txAntennaElements{4};  //!< number of rows and columns of tx antenna array
+    uint32_t m_rxAntennaElements{4};  //!< number of rows and columns of rx antenna array
+    uint32_t m_txPorts{1}; //!< number of horizontal and vertical ports of tx antenna array
+    uint32_t m_rxPorts{1}; //!< number of horizontal and vertical ports of rx antenna array
 };
 
-ThreeGppChannelMatrixComputationTest::ThreeGppChannelMatrixComputationTest()
+ThreeGppChannelMatrixComputationTest::ThreeGppChannelMatrixComputationTest(
+    uint32_t txAntennaElements,
+    uint32_t rxAntennaElements,
+    uint32_t txPorts,
+    uint32_t rxPorts)
     : TestCase("Check the dimensions and the norm of the channel matrix")
 {
+    m_txAntennaElements = txAntennaElements;
+    m_rxAntennaElements = rxAntennaElements;
+    m_txPorts = txPorts;
+    m_rxPorts = rxPorts;
 }
 
 ThreeGppChannelMatrixComputationTest::~ThreeGppChannelMatrixComputationTest()
@@ -99,8 +125,8 @@
                                                     Ptr<PhasedArrayModel> txAntenna,
                                                     Ptr<PhasedArrayModel> rxAntenna)
 {
-    uint64_t txAntennaElements = txAntenna->GetNumberOfElements();
-    uint64_t rxAntennaElements = rxAntenna->GetNumberOfElements();
+    uint64_t txAntennaElements = txAntenna->GetNumElems();
+    uint64_t rxAntennaElements = rxAntenna->GetNumElems();
 
     Ptr<const ThreeGppChannelModel::ChannelMatrix> channelMatrix =
         channelModel->GetChannel(txMob, rxMob, txAntenna, rxAntenna);
@@ -126,10 +152,10 @@
 void
 ThreeGppChannelMatrixComputationTest::DoRun()
 {
+    RngSeedManager::SetSeed(1);
+    RngSeedManager::SetRun(1);
     // Build the scenario for the test
-    uint8_t txAntennaElements[]{2, 2}; // tx antenna dimensions
-    uint8_t rxAntennaElements[]{2, 2}; // rx antenna dimensions
-    uint32_t updatePeriodMs = 100;     // update period in ms
+    uint32_t updatePeriodMs = 100; // update period in ms
 
     // create the channel condition model
     Ptr<ChannelConditionModel> channelConditionModel =
@@ -141,6 +167,7 @@
     channelModel->SetAttribute("Scenario", StringValue("RMa"));
     channelModel->SetAttribute("ChannelConditionModel", PointerValue(channelConditionModel));
     channelModel->SetAttribute("UpdatePeriod", TimeValue(MilliSeconds(updatePeriodMs - 1)));
+    channelModel->AssignStreams(1);
 
     // create the tx and rx nodes
     NodeContainer nodes;
@@ -169,19 +196,27 @@
     // create the tx and rx antennas and set the their dimensions
     Ptr<PhasedArrayModel> txAntenna = CreateObjectWithAttributes<UniformPlanarArray>(
         "NumColumns",
-        UintegerValue(txAntennaElements[0]),
+        UintegerValue(m_txAntennaElements),
         "NumRows",
-        UintegerValue(txAntennaElements[1]),
+        UintegerValue(m_txAntennaElements),
         "AntennaElement",
-        PointerValue(CreateObject<IsotropicAntennaModel>()));
+        PointerValue(CreateObject<IsotropicAntennaModel>()),
+        "NumVerticalPorts",
+        UintegerValue(m_txPorts),
+        "NumHorizontalPorts",
+        UintegerValue(m_txPorts));
+
     Ptr<PhasedArrayModel> rxAntenna = CreateObjectWithAttributes<UniformPlanarArray>(
         "NumColumns",
-        UintegerValue(rxAntennaElements[0]),
+        UintegerValue(m_rxAntennaElements),
         "NumRows",
-        UintegerValue(rxAntennaElements[1]),
+        UintegerValue(m_rxAntennaElements),
         "AntennaElement",
-        PointerValue(CreateObject<IsotropicAntennaModel>()));
-
+        PointerValue(CreateObject<IsotropicAntennaModel>()),
+        "NumVerticalPorts",
+        UintegerValue(m_rxPorts),
+        "NumHorizontalPorts",
+        UintegerValue(m_rxPorts));
     // generate the channel matrix
     Ptr<const ThreeGppChannelModel::ChannelMatrix> channelMatrix =
         channelModel->GetChannel(txMob, rxMob, txAntenna, rxAntenna);
@@ -189,11 +224,11 @@
     // check the channel matrix dimensions, expected H[cluster][rx][tx]
     NS_TEST_ASSERT_MSG_EQ(
         channelMatrix->m_channel.GetNumCols(),
-        txAntennaElements[0] * txAntennaElements[1],
+        m_txAntennaElements * m_txAntennaElements,
         "The third dimension of H should be equal to the number of tx antenna elements");
     NS_TEST_ASSERT_MSG_EQ(
         channelMatrix->m_channel.GetNumRows(),
-        rxAntennaElements[0] * rxAntennaElements[1],
+        m_rxAntennaElements * m_rxAntennaElements,
         "The second dimension of H should be equal to the number of rx antenna elements");
 
     // test if the channel matrix is correctly generated
@@ -232,9 +267,9 @@
     // the hypothesis "E [|H|^2] = M*N, where |H| indicates the Frobenius norm of
     // H, M is the number of transmit antenna elements, and N is the number of
     // the receive antenna elements"
-    double t = (sampleMean - txAntennaElements[0] * txAntennaElements[1] * rxAntennaElements[0] *
-                                 rxAntennaElements[1]) /
-               (sampleMean / std::sqrt(numIt));
+    double t = (sampleMean - m_txAntennaElements * m_txAntennaElements * m_rxAntennaElements *
+                                 m_rxAntennaElements) /
+               (sampleStd / std::sqrt(numIt));
 
     // Using a significance level of 0.05, we reject the null hypothesis if |t| is
     // greater than the critical value from a t-distribution with df = numIt-1
@@ -258,9 +293,19 @@
 {
   public:
     /**
-     * Constructor
+     *Constructor
+     * \param txAntennaElements the number of rows and columns of the antenna array of the
+     * transmitter
+     * \param rxAntennaElements the number of rows and columns of the antenna array of
+     * \param txPorts the number of vertical and horizontal ports of the antenna array
+     * of the transmitter
+     * \param rxPorts the number of vertical and horizontal ports of the antenna
+     * array of the receiver
      */
-    ThreeGppChannelMatrixUpdateTest();
+    ThreeGppChannelMatrixUpdateTest(uint32_t txAntennaElements = 2,
+                                    uint32_t rxAntennaElements = 4,
+                                    uint32_t txPorts = 1,
+                                    uint32_t rxPorts = 1);
 
     /**
      * Destructor
@@ -291,12 +336,23 @@
                       bool update);
 
     Ptr<const ThreeGppChannelModel::ChannelMatrix>
-        m_currentChannel; //!< used by DoGetChannel to store the current channel matrix
+        m_currentChannel;            //!< used by DoGetChannel to store the current channel matrix
+    uint32_t m_txAntennaElements{4}; //!< number of rows and columns of tx antenna array
+    uint32_t m_rxAntennaElements{4}; //!< number of rows and columns of rx antenna array
+    uint32_t m_txPorts{1}; //!< number of horizontal and vertical ports of tx antenna array
+    uint32_t m_rxPorts{1}; //!< number of horizontal and vertical ports of rx antenna array
 };
 
-ThreeGppChannelMatrixUpdateTest::ThreeGppChannelMatrixUpdateTest()
+ThreeGppChannelMatrixUpdateTest::ThreeGppChannelMatrixUpdateTest(uint32_t txAntennaElements,
+                                                                 uint32_t rxAntennaElements,
+                                                                 uint32_t txPorts,
+                                                                 uint32_t rxPorts)
     : TestCase("Check if the channel realizations are correctly updated during the simulation")
 {
+    m_txAntennaElements = txAntennaElements;
+    m_rxAntennaElements = rxAntennaElements;
+    m_txPorts = txPorts;
+    m_rxPorts = rxPorts;
 }
 
 ThreeGppChannelMatrixUpdateTest::~ThreeGppChannelMatrixUpdateTest()
@@ -324,7 +380,7 @@
     else
     {
         // compare the old and the new channel matrices
-        NS_TEST_ASSERT_MSG_EQ((m_currentChannel != channelMatrix),
+        NS_TEST_ASSERT_MSG_EQ((m_currentChannel->m_channel != channelMatrix->m_channel),
                               update,
                               Simulator::Now().GetMilliSeconds()
                                   << " The channel matrix is not correctly updated");
@@ -335,10 +391,7 @@
 ThreeGppChannelMatrixUpdateTest::DoRun()
 {
     // Build the scenario for the test
-
-    uint8_t txAntennaElements[]{2, 2}; // tx antenna dimensions
-    uint8_t rxAntennaElements[]{4, 4}; // rx antenna dimensions
-    uint32_t updatePeriodMs = 100;     // update period in ms
+    uint32_t updatePeriodMs = 100; // update period in ms
 
     // create the channel condition model
     Ptr<ChannelConditionModel> channelConditionModel =
@@ -378,18 +431,27 @@
     // create the tx and rx antennas and set the their dimensions
     Ptr<PhasedArrayModel> txAntenna = CreateObjectWithAttributes<UniformPlanarArray>(
         "NumColumns",
-        UintegerValue(txAntennaElements[0]),
+        UintegerValue(m_txAntennaElements),
         "NumRows",
-        UintegerValue(txAntennaElements[1]),
+        UintegerValue(m_txAntennaElements),
         "AntennaElement",
-        PointerValue(CreateObject<IsotropicAntennaModel>()));
+        PointerValue(CreateObject<IsotropicAntennaModel>()),
+        "NumVerticalPorts",
+        UintegerValue(m_txPorts),
+        "NumHorizontalPorts",
+        UintegerValue(m_txPorts));
+
     Ptr<PhasedArrayModel> rxAntenna = CreateObjectWithAttributes<UniformPlanarArray>(
         "NumColumns",
-        UintegerValue(rxAntennaElements[0]),
+        UintegerValue(m_rxAntennaElements),
         "NumRows",
-        UintegerValue(rxAntennaElements[1]),
+        UintegerValue(m_rxAntennaElements),
         "AntennaElement",
-        PointerValue(CreateObject<IsotropicAntennaModel>()));
+        PointerValue(CreateObject<IsotropicAntennaModel>()),
+        "NumVerticalPorts",
+        UintegerValue(m_rxPorts),
+        "NumHorizontalPorts",
+        UintegerValue(m_rxPorts));
 
     // check if the channel matrix is correctly updated
 
@@ -467,9 +529,19 @@
   public:
     /**
      * Constructor
+     * \param txAntennaElements the number of rows and columns of the antenna array of the
+     * transmitter
+     * \param rxAntennaElements the number of rows and columns of the antenna array of
+     * the receiver
+     * \param txPorts the number of vertical and horizontal ports of the antenna array
+     * of the transmitter
+     * \param rxPorts the number of vertical and horizontal ports of the antenna
+     * array of the receiver
      */
-    ThreeGppSpectrumPropagationLossModelTest();
-
+    ThreeGppSpectrumPropagationLossModelTest(uint32_t txAntennaElements = 4,
+                                             uint32_t rxAntennaElements = 4,
+                                             uint32_t txPorts = 1,
+                                             uint32_t rxPorts = 1);
     /**
      * Destructor
      */
@@ -501,18 +573,23 @@
      */
     void CheckLongTermUpdate(const CheckLongTermUpdateParams& params);
 
-    /**
-     * Checks if two PSDs are equal
-     * \param first the first PSD
-     * \param second the second PSD
-     * \return true if first and second are equal, false otherwise
-     */
-    static bool ArePsdEqual(Ptr<SpectrumValue> first, Ptr<SpectrumValue> second);
+    uint32_t m_txAntennaElements{4}; //!< number of rows and columns of tx antenna array
+    uint32_t m_rxAntennaElements{4}; //!< number of rows and columns of rx antenna array
+    uint32_t m_txPorts{1}; //!< number of horizontal and vertical ports of tx antenna array
+    uint32_t m_rxPorts{1}; //!< number of horizontal and vertical ports of rx antenna array
 };
 
-ThreeGppSpectrumPropagationLossModelTest::ThreeGppSpectrumPropagationLossModelTest()
+ThreeGppSpectrumPropagationLossModelTest::ThreeGppSpectrumPropagationLossModelTest(
+    uint32_t txAntennaElements,
+    uint32_t rxAntennaElements,
+    uint32_t txPorts,
+    uint32_t rxPorts)
     : TestCase("Test case for the ThreeGppSpectrumPropagationLossModel class")
 {
+    m_txAntennaElements = txAntennaElements;
+    m_rxAntennaElements = rxAntennaElements;
+    m_txPorts = txPorts;
+    m_rxPorts = rxPorts;
 }
 
 ThreeGppSpectrumPropagationLossModelTest::~ThreeGppSpectrumPropagationLossModelTest()
@@ -536,32 +613,16 @@
     thisAntenna->SetBeamformingVector(antennaWeights);
 }
 
-bool
-ThreeGppSpectrumPropagationLossModelTest::ArePsdEqual(Ptr<SpectrumValue> first,
-                                                      Ptr<SpectrumValue> second)
-{
-    bool ret = true;
-    for (uint8_t i = 0; i < first->GetSpectrumModel()->GetNumBands(); i++)
-    {
-        if ((*first)[i] != (*second)[i])
-        {
-            ret = false;
-            continue;
-        }
-    }
-    return ret;
-}
-
 void
 ThreeGppSpectrumPropagationLossModelTest::CheckLongTermUpdate(
     const CheckLongTermUpdateParams& params)
 {
-    Ptr<SpectrumValue> rxPsdNew = params.lossModel->DoCalcRxPowerSpectralDensity(params.txParams,
-                                                                                 params.txMob,
-                                                                                 params.rxMob,
-                                                                                 params.txAntenna,
-                                                                                 params.rxAntenna);
-    NS_TEST_ASSERT_MSG_EQ(ArePsdEqual(params.rxPsdOld, rxPsdNew),
+    auto rxPsdNewParams = params.lossModel->DoCalcRxPowerSpectralDensity(params.txParams,
+                                                                         params.txMob,
+                                                                         params.rxMob,
+                                                                         params.txAntenna,
+                                                                         params.rxAntenna);
+    NS_TEST_ASSERT_MSG_EQ((*params.rxPsdOld == *rxPsdNewParams->psd),
                           false,
                           "The long term is not updated when the channel matrix is recomputed");
 }
@@ -572,9 +633,6 @@
     // Build the scenario for the test
     Config::SetDefault("ns3::ThreeGppChannelModel::UpdatePeriod", TimeValue(MilliSeconds(100)));
 
-    uint8_t txAntennaElements[]{4, 4}; // tx antenna dimensions
-    uint8_t rxAntennaElements[]{4, 4}; // rx antenna dimensions
-
     // create the ChannelConditionModel object to be used to retrieve the
     // channel condition
     Ptr<ChannelConditionModel> condModel = CreateObject<AlwaysLosChannelConditionModel>();
@@ -618,18 +676,27 @@
     // create the tx and rx antennas and set the their dimensions
     Ptr<PhasedArrayModel> txAntenna = CreateObjectWithAttributes<UniformPlanarArray>(
         "NumColumns",
-        UintegerValue(txAntennaElements[0]),
+        UintegerValue(m_txAntennaElements),
         "NumRows",
-        UintegerValue(txAntennaElements[1]),
+        UintegerValue(m_rxAntennaElements),
         "AntennaElement",
-        PointerValue(CreateObject<IsotropicAntennaModel>()));
+        PointerValue(CreateObject<IsotropicAntennaModel>()),
+        "NumVerticalPorts",
+        UintegerValue(m_txPorts),
+        "NumHorizontalPorts",
+        UintegerValue(m_txPorts));
+
     Ptr<PhasedArrayModel> rxAntenna = CreateObjectWithAttributes<UniformPlanarArray>(
         "NumColumns",
-        UintegerValue(rxAntennaElements[0]),
+        UintegerValue(m_rxAntennaElements),
         "NumRows",
-        UintegerValue(rxAntennaElements[1]),
+        UintegerValue(m_rxAntennaElements),
         "AntennaElement",
-        PointerValue(CreateObject<IsotropicAntennaModel>()));
+        PointerValue(CreateObject<IsotropicAntennaModel>()),
+        "NumVerticalPorts",
+        UintegerValue(m_rxPorts),
+        "NumHorizontalPorts",
+        UintegerValue(m_rxPorts));
 
     // set the beamforming vectors
     DoBeamforming(txDev, txAntenna, rxDev, rxAntenna);
@@ -644,13 +711,13 @@
     txParams->psd = txPsd->Copy();
 
     // compute the rx psd
-    Ptr<SpectrumValue> rxPsdOld =
+    auto rxParamsOld =
         lossModel->DoCalcRxPowerSpectralDensity(txParams, txMob, rxMob, txAntenna, rxAntenna);
 
     // 1) check that the rx PSD is equal for both the direct and the reverse channel
-    Ptr<SpectrumValue> rxPsdNew =
+    auto rxParamsNew =
         lossModel->DoCalcRxPowerSpectralDensity(txParams, rxMob, txMob, rxAntenna, txAntenna);
-    NS_TEST_ASSERT_MSG_EQ(ArePsdEqual(rxPsdOld, rxPsdNew),
+    NS_TEST_ASSERT_MSG_EQ((*rxParamsOld->psd == *rxParamsNew->psd),
                           true,
                           "The long term for the direct and the reverse channel are different");
 
@@ -661,18 +728,23 @@
     txBfVector[0] = std::complex<double>(0.0, 0.0);
     txAntenna->SetBeamformingVector(txBfVector);
 
-    rxPsdNew =
+    rxParamsNew =
         lossModel->DoCalcRxPowerSpectralDensity(txParams, rxMob, txMob, rxAntenna, txAntenna);
-    NS_TEST_ASSERT_MSG_EQ(ArePsdEqual(rxPsdOld, rxPsdNew),
+    NS_TEST_ASSERT_MSG_EQ((*rxParamsOld->psd == *rxParamsNew->psd),
                           false,
                           "Changing the BF vectors the rx PSD does not change");
 
+    NS_TEST_ASSERT_MSG_EQ(
+        (*rxParamsOld->spectrumChannelMatrix == *rxParamsNew->spectrumChannelMatrix),
+        false,
+        "Changing the BF should change de frequency domain channel matrix");
+
     // update rxPsdOld
-    rxPsdOld = rxPsdNew;
+    rxParamsOld = rxParamsNew;
 
     // 3) check if the long term is updated when the channel matrix is recomputed
     CheckLongTermUpdateParams
-        params{lossModel, txParams, txMob, rxMob, rxPsdOld, txAntenna, rxAntenna};
+        params{lossModel, txParams, txMob, rxMob, rxParamsOld->psd, txAntenna, rxAntenna};
     Simulator::Schedule(MilliSeconds(101),
                         &ThreeGppSpectrumPropagationLossModelTest::CheckLongTermUpdate,
                         this,
